import unittest
class Solution:
    def isValid(self, x: str) -> bool:
        dic = {
            "(":")",
            "[":"]",
            "{":"}",
            "?":"?"
        }
        stack = ["?"]
        for i in x:
            if i in dic:
                stack.append(i)
            elif dic[stack.pop()] != i:
                return False
        return len(stack) == 1






class TestisValid(unittest.TestCase):
    def test_isValid(self):
        x = "()()"
        s = Solution()
        res = s.isValid(x)
        self.assertEqual(res, True)
    def test_isValid2(self):
        x = "()[]{}"
        s = Solution()
        res = s.isValid(x)
        self.assertEqual(res, True)

    def test_isValid3(self):
        x = "(]"
        s = Solution()
        res = s.isValid(x)
        self.assertEqual(res, False)


    def test_isValid4(self):
        x = "([)]"
        s = Solution()
        res = s.isValid(x)
        self.assertEqual(res, False)
    def test_isValid4(self):
        x = "(({)[})"
        s = Solution()
        res = s.isValid(x)
        self.assertEqual(res, False)