from LinkedList_Module import ListNode
from typing import Optional
import unittest

# Definition for singly-linked list.
# class ListNode:
#     def __init__(self, val=0, next=None):
#         self.val = val
#         self.next = next
class Solution:
    def mergeTwoLists(self, list1: Optional[ListNode], list2: Optional[ListNode]) -> Optional[ListNode]:
        if not list1:
            return list2
        if not list2:
            return list1
        if list1.val <= list2.val:
            list1.next = self.mergeTwoLists(list1.next,list2)
            return list1
        else:
            list2.next = self.mergeTwoLists(list1,list2.next)
            return list2



class TestmergeTwoLists(unittest.TestCase):
    def test_mergeTwoLists(self):
        list1 = ListNode(1,2,4)
        list2 = ListNode(1,3,4)
        s = Solution()
        res = s.mergeTwoLists(list1,list2)
        self.assertEqual(res, "1,1,2,3,4,4")