from typing import List
import unittest

class Solution:
    def longestCommonPrefix(self, strs: List[str]) -> str:
        if not strs: return ""
        str0 = min(strs)
        str1 = max(strs)
        for i in range(len(str0)):
            if str0[i] != str1[i]:
                return str0[:i]
        return str0



class TestlongestCommonPrefix(unittest.TestCase):
    def test_longestCommonPrefix(self):
        strs = ["flower","flow","flight"]
        s = Solution()
        res = s.longestCommonPrefix(strs)
        self.assertEqual(res, "fl")

    def test_longestCommonPrefix1(self):
        strs = ["dog","racecar","car"]
        s = Solution()
        res = s.longestCommonPrefix(strs)
        self.assertEqual(res, "")

    def test_longestCommonPrefix(self):
        strs = ["flower","flow","flowight"]
        s = Solution()
        res = s.longestCommonPrefix(strs)
        self.assertEqual(res, "flow")